function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var _excluded = ["highlight", "ellipsis", "children"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { useState, useImperativeHandle, forwardRef, useRef, useEffect } from 'react';
// Ellipsis
import getEllipsisVisibleContent from "./getEllipsisVisibleContent";
import getEllipsisOverflow from "./getEllipsisOverflow";
// Highlight
import getHighlightNode from "./getHighlightNode";

// 内库使用-start
import LocaleUtil from "./../../../../utils/LocaleUtil";
import DOMUtil from "./../../../../utils/DOMUtil";
// 内库使用-end

/* 测试使用-start
import { LocaleUtil, DOMUtil } from 'seedsui-react'
测试使用-end */

var Base = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var _ellipsis$expanded;
  var highlight = _ref.highlight,
    ellipsis = _ref.ellipsis,
    children = _ref.children,
    props = _objectWithoutProperties(_ref, _excluded);
  var rootRef = useRef(null);

  // Ellipsis expanded and toggle button
  var _useState = useState(((_ellipsis$expanded = ellipsis === null || ellipsis === void 0 ? void 0 : ellipsis.expanded) !== null && _ellipsis$expanded !== void 0 ? _ellipsis$expanded : ellipsis === null || ellipsis === void 0 ? void 0 : ellipsis.rows) ? false : true),
    _useState2 = _slicedToArray(_useState, 2),
    expanded = _useState2[0],
    setExpanded = _useState2[1];
  var _useState3 = useState(false),
    _useState4 = _slicedToArray(_useState3, 2),
    toggleVisible = _useState4[0],
    setToggleVisible = _useState4[1];
  var _useState5 = useState(''),
    _useState6 = _slicedToArray(_useState5, 2),
    visibleContent = _useState6[0],
    setVisibleContent = _useState6[1];

  // Expose
  useImperativeHandle(ref, function () {
    return {
      rootDOM: rootRef.current,
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      },
      // Ellipsis
      toggleEllipsis: function toggleEllipsis() {
        var newExpanded = !expanded;
        setExpanded(newExpanded);
        return newExpanded;
      },
      hasEllipsis: function hasEllipsis() {
        return function () {
          return getEllipsisOverflow({
            rows: ellipsis === null || ellipsis === void 0 ? void 0 : ellipsis.rows,
            rowHeight: ellipsis === null || ellipsis === void 0 ? void 0 : ellipsis.rowHeight,
            containerDOM: rootRef.current
          });
        };
      }
    };
  });
  useEffect(function () {
    // 如果没有展开收起按钮, 不需要计算溢出, 用样式控制即可
    if (ellipsis !== null && ellipsis !== void 0 && ellipsis.rows && ellipsis !== null && ellipsis !== void 0 && ellipsis.expandable && typeof children === 'string') {
      updateEllipsis();
    }
    // eslint-disable-next-line
  }, [ellipsis === null || ellipsis === void 0 ? void 0 : ellipsis.rows, ellipsis === null || ellipsis === void 0 ? void 0 : ellipsis.expandable, children]);

  // 更新Ellipsis的toggleVisible和visibleContent
  function updateEllipsis() {
    // 判断是否显示展开收起按钮
    var newToggleVisible = getEllipsisOverflow({
      rows: ellipsis === null || ellipsis === void 0 ? void 0 : ellipsis.rows,
      rowHeight: ellipsis === null || ellipsis === void 0 ? void 0 : ellipsis.rowHeight,
      containerDOM: rootRef.current
    });
    setToggleVisible(newToggleVisible);
    if (!newToggleVisible) return;
    // 有展开或者收起按钮时, 需要计算内容
    var newContent = getEllipsisVisibleContent({
      content: children,
      rows: ellipsis === null || ellipsis === void 0 ? void 0 : ellipsis.rows,
      rowHeight: ellipsis === null || ellipsis === void 0 ? void 0 : ellipsis.rowHeight,
      containerDOM: rootRef.current
    });
    setVisibleContent(newContent);
  }
  return /*#__PURE__*/React.createElement("div", _extends({}, props, {
    className: DOMUtil.classNames(typeof (ellipsis === null || ellipsis === void 0 ? void 0 : ellipsis.rows) === 'number' ? ' typography-ellipsis' : '', props.className),
    style: _objectSpread({
      WebkitLineClamp: expanded ? undefined : ellipsis === null || ellipsis === void 0 ? void 0 : ellipsis.rows,
      height: expanded ? undefined : (ellipsis === null || ellipsis === void 0 ? void 0 : ellipsis.rows) * ((ellipsis === null || ellipsis === void 0 ? void 0 : ellipsis.rowHeight) || 20) + 'px'
    }, props === null || props === void 0 ? void 0 : props.style),
    ref: rootRef
  }), getHighlightNode(expanded === false && visibleContent ? visibleContent : children, highlight), toggleVisible && /*#__PURE__*/React.createElement("div", {
    className: "typography-ellipsis-toggle",
    onClick: function onClick(e) {
      e.stopPropagation();
      setExpanded(!expanded);
    }
  }, expanded ? LocaleUtil.locale('收起', 'SeedsUI_typography_ellipsis_toggle_collapse') : LocaleUtil.locale('展开', 'SeedsUI_typography_ellipsis_toggle_expand')));
});
export default Base;